This accessibility statement applies to the Submit social housing lettings and sales data (CORE) online service.

This website is run by the Department for Levelling Up, Housing and Communities (DLUHC). We want as many people as possible to be able to use this website. For example, that means you should be able to:

- change colours, contrast levels and fonts
- zoom in up to 300% without the text spilling off the screen
- navigate most of the website using just a keyboard
- navigate most of the website using speech recognition software
- listen to most of the website using a screen reader (including the most recent versions of JAWS, NVDA and VoiceOver)

We’ve also made the website text as simple as possible to understand.

[AbilityNet has advice on making your device easier to use](https://mcmw.abilitynet.org.uk/) if you have a disability.

### How accessible this website is

We know some parts of this website are not fully accessible:

- an empty link on the ‘Users’ page within ‘Your Organisation’ will cause problems for some users of assistive technology (A)
- an optional field is not clearly labelled on the ‘Invite user to submit CORE data’ page (A)
- a skip link for an error message on the ‘Household’s combined income after tax’ page doesn’t work (A)
- radio buttons on multiple pages had different functionality depending on the browser used (AAA)
- the required currency symbol on the ‘Household’s combined income after tax’ page is hidden from the label for users of screen readers (AAA)
- the input type ‘email’ interferes with Dragon voice activation software on the ‘Sign in to your account to submit CORE data page’ (AAA)

### Feedback and contact information

If you need information on this website in a different format like accessible PDF, large print, easy read, audio recording or braille, you can contact us by:

- email: [dluhc.digital-services@levellingup.gov.uk](mailto: dluhc.digital-services@levellingup.gov.uk)
- phone: 0333 202 5084

We’ll consider your request and get back to you in 2 working days.

You can also [contact us through the helpdesk](https://digital.dclg.gov.uk/jira/servicedesk/customer/portal/4/).

### Reporting accessibility problems with this website

We’re always looking to improve the accessibility of this website. If you find any problems not listed on this page or think we’re not meeting accessibility requirements, [contact the helpdesk](https://digital.dclg.gov.uk/jira/servicedesk/customer/portal/4/).

### Enforcement procedure

The Equality and Human Rights Commission (EHRC) is responsible for enforcing the Public Sector Bodies (Websites and Mobile Applications) (No. 2) Accessibility Regulations 2018 (the ‘accessibility regulations’). If you’re not happy with how we respond to your complaint, [contact the Equality Advisory and Support Service (EASS)](https://www.equalityadvisoryservice.com/).

## Technical information about this website’s accessibility

DLUHC is committed to making its website accessible, in accordance with the Public Sector Bodies (Websites and Mobile Applications) (No. 2) Accessibility Regulations 2018.

### Compliance status

This website is partially compliant with the [Web Content Accessibility Guidelines version 2.1](https://www.w3.org/TR/WCAG21/) AA standard due to the non-compliances listed below.

## Non-accessible content

The content listed below is non-accessible for the following reasons.

### Non-compliance with the accessibility regulations

An empty link on the ‘Users’ page within ‘Your Organisation’ will cause problems for some users of assistive technology. This fails WCAG 2.1 success criteria 2.4.4 Link Purpose – in context (Level A) and 3.3.2 Labels or Instructions (Level A).

We plan to fix this by December 2022.

An optional field is not clearly labelled on the ‘Invite user to submit CORE data’ page. This fails WCAG 2.1 success criteria 3.3.2 Labels or Instructions (Level A).

We plan to fix this by December 2022.

A skip link for an error message on the ‘Household’s combined income after tax’ page doesn’t work. This fails WCAG 2.1 success criteria 4.1.2 Name, Role, Value (Level A).

We plan to fix this by December 2022.

## Preparation of this accessibility statement

This statement was prepared on 27 July 2022. It was last reviewed on 1 August 2022.

This website was last tested on 14 March 2022. The test was carried out by the Digital Accessibility Centre (DAC).
