require "rails_helper"

RSpec.describe Form::Lettings::Questions::Wheelchair, type: :model do
  subject(:question) { described_class.new(nil, nil, page) }

  let(:page) { instance_double(Form::Page) }

  it "has correct page" do
    expect(question.page).to eq(page)
  end

  it "has the correct id" do
    expect(question.id).to eq("wchair")
  end

  it "has the correct header" do
    expect(question.header).to eq("Is the property built or adapted to wheelchair-user standards?")
  end

  it "has the correct check_answer_label" do
    expect(question.check_answer_label).to eq("Property built or adapted to wheelchair-user standards")
  end

  it "has the correct type" do
    expect(question.type).to eq("radio")
  end

  it "has the correct hint_text" do
    expect(question.hint_text).to eq ""
  end

  it "has the correct answer_options" do
    expect(question.answer_options).to eq({
      "1" => { "value" => "Yes" },
      "2" => { "value" => "No" },
    })
  end

  it "is not marked as derived" do
    expect(question.derived?).to be false
  end
end
